Bug 846290 - Don't install system-config-printer in the desktop spin by default
Don't install system-config-printer in the desktop spin by default
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: system-config-printer (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Tim Waugh
Fedora Extras Quality Assurance
:
Depends On:
Blocks: F15-accepted/F15FinalFreezeExcept
  Show dependency treegraph
 
Reported: 2012-08-07 07:01 EDT by Allan Day
Modified: 2015-02-18 06:08 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 06:08:42 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
proposed comps change (3.00 KB, patch)
2014-07-18 19:04 EDT, Tim Waugh
no flags Details | Diff

  None (edit)
Description Allan Day 2012-08-07 07:01:30 EDT
GNOME System Settings is designed to be a single access point for all system level configuration, including printing. system-config-printer does not fit with this model and reproduces functionality found in GNOME System Settings. It also adds an unecessary application launcher to the applications view.

It would be better if it wasn't installed in the desktop spin by default.
Comment 1 Tim Waugh 2012-08-07 07:39:55 EDT
There are important features only provided by system-config-printer, such as setting up queues for network printers, and sharing local printers.
Comment 2 Allan Day 2012-08-07 09:06:10 EDT
(In reply to comment #1)
> There are important features only provided by system-config-printer, such as
> setting up queues for network printers, and sharing local printers.

People can always install system-config-printer if they need those features.
Comment 3 Tim Waugh 2012-08-07 10:48:42 EDT
Printing to a network printer is one of the most common requirements for printing.
Comment 4 Allan Day 2012-08-07 11:24:47 EDT
(In reply to comment #3)
> Printing to a network printer is one of the most common requirements for
> printing.

Can't you set that up with System Settings?
Comment 5 Tim Waugh 2012-08-08 04:42:01 EDT
See e.g. bug #805289, bug #829083, bug #831246.
Comment 6 Allan Day 2012-08-08 05:05:22 EDT
(In reply to comment #5)
> See e.g. bug #805289, bug #829083, bug #831246.

My understanding is that those bugs are getting fixed for GNOME 3.6/Fedora 18. CC'ing Marek Kašík, who is currently working on printing in GNOME System Settings.
Comment 7 Marek Kašík 2012-08-08 11:37:43 EDT
Hi,

805289 - Adding samba printer doesn't work in gnome-control-center
  - I would like to add it to 3.6 but I'm not sure whether it will be ready in time (see https://bugzilla.gnome.org/show_bug.cgi?id=678637)

829083 - Printer config wizard fails to find printers
  - it looks like a problem of the printer. Running "/usr/lib/backend/snmp the-address" returns class, uri, make and model, info, location of the printer but not its device id. So the dialog doesn't list it (maybe it should, I'll try it).

831246 - "Add a New Printer" dialog hangs
  - this shouldn't happen with the new dialog (not committed yet)
  - see https://bugzilla.gnome.org/show_bug.cgi?id=678637


The truth is that the panel doesn't support setting of sharing of printers and server settings but it should be able to set up queues for network printers (except the samba shares for now).
Another problem can be that I will remove setting of firewall from the new printer dialog because there were some concerns about security.
Comment 8 Robyn Bergeron 2012-08-11 10:07:10 EDT
I find it a bit ridiculous that we would consider removing system-config-printer from a default installation.

* To say that "system-config-printer reproduces functionality found in GNOME system settings" may be slightly true; I think to say that the printer function in gnome system settings does not reproduce the more comprehensive functionality found in system-config-printer would probably be a more accurate statement.

* Having end-users just install system-config-printer if they need the additional functionality doesn't strike me as a user-friendly option. I, end user, am incredibly unlikely to think that my distribution of choice has an additional printer manager that has more functionality than the one presented to me; I generally expect that the most feature-complete method will be the default.

* I see nothing about an upgrade path here. What happens to people who already utilize the capabilities in system-config-printer that are not supported in GNOME system settings?

Overall, I see very little awesomeness in making the sole option for printing at install time be a choice which is essentially a regression from what Fedora has provided in the past.

If the goal is to unclutter the applications view, as described in https://fedoraproject.org/wiki/Design/F18_Launcher_Purge -- perhaps the more appropriate option would be to leave system-config-printer and remove printing from gnome system settings within Fedora, until gnome has feature parity.

Regardless, a change like this (removing system-config-printer from default) would likely need to follow the feature process; documentation would need to change, other desktops need to not be adversely affected, release notes would be needed, upgrade questions answered. We are well past the submission deadline, and nearly a week past feature freeze, at this point, for F18.
Comment 9 Allan Day 2012-08-11 14:24:49 EDT
(In reply to comment #8)
> I find it a bit ridiculous that we would consider removing
> system-config-printer from a default installation.
> 
> * To say that "system-config-printer reproduces functionality found in GNOME
> system settings" may be slightly true; I think to say that the printer
> function in gnome system settings does not reproduce the more comprehensive
> functionality found in system-config-printer would probably be a more
> accurate statement.

Marek has been working hard to add any essential missing functionality to System Settings printing this cycle. I'm hopeful that we'll have that covered for GNOME 3.6.

> * Having end-users just install system-config-printer if they need the
> additional functionality doesn't strike me as a user-friendly option. I, end
> user, am incredibly unlikely to think that my distribution of choice has an
> additional printer manager that has more functionality than the one
> presented to me; I generally expect that the most feature-complete method
> will be the default.

I would expect System Settings to contain essential printing functionality. It's purpose is to provide a centralised UI for system level operations; this is what all the other major OSs do, and will be familiar to users of those systems.

Using specialist tools for advanced functionality is quite common. We just need to make sure that System Settings covers the basics.

> * I see nothing about an upgrade path here. What happens to people who
> already utilize the capabilities in system-config-printer that are not
> supported in GNOME system settings?

If someone misses system-config-printer, they can simply install it. That's the natural thing to do if you want to use a tool that isn't currently installed.

> Overall, I see very little awesomeness in making the sole option for
> printing at install time be a choice which is essentially a regression from
> what Fedora has provided in the past.

This would be a great move for the default desktop user experience. It would ensure that System Settings is able to play its role as a one-stop-shop for system-level activities. It would also help to clean up the Activities Overview, which will be a huge improvement. Making it easier to find and launch applications is vital.

> If the goal is to unclutter the applications view, as described in
> https://fedoraproject.org/wiki/Design/F18_Launcher_Purge -- perhaps the more
> appropriate option would be to leave system-config-printer and remove
> printing from gnome system settings within Fedora, until gnome has feature
> parity.

That wouldn't help - you would still have the same number of launchers in the applications view, and it would be confusing to users who cannot find printing under system settings (which is the natural place for it).

Having two printer configuration UIs is really confusing. People will expect printing to be under System Settings, and for it to cover essential functionality. They will not understand why there are two separate configuration utilities. We really need to make this better for our users.
 
> Regardless, a change like this (removing system-config-printer from default)
> would likely need to follow the feature process; documentation would need to
> change, other desktops need to not be adversely affected, release notes
> would be needed, upgrade questions answered. We are well past the submission
> deadline, and nearly a week past feature freeze, at this point, for F18.

I've consulted a number of people in the Fedora community about this, and no one else has said that these changes should be proposed as a feature. I can communicate any changes to the documentation team, should that be necessary.
Comment 10 Robyn Bergeron 2012-08-13 09:21:46 EDT
(In reply to comment #9)
> (In reply to comment #8)
> > I find it a bit ridiculous that we would consider removing
> > system-config-printer from a default installation.
> > 
> > * To say that "system-config-printer reproduces functionality found in GNOME
> > system settings" may be slightly true; I think to say that the printer
> > function in gnome system settings does not reproduce the more comprehensive
> > functionality found in system-config-printer would probably be a more
> > accurate statement.
> 
> Marek has been working hard to add any essential missing functionality to
> System Settings printing this cycle. I'm hopeful that we'll have that
> covered for GNOME 3.6.

"Hopeful" doesn't really sound like "totally ready to take system-config-printer out right this second."

> 
> > * Having end-users just install system-config-printer if they need the
> > additional functionality doesn't strike me as a user-friendly option. I, end
> > user, am incredibly unlikely to think that my distribution of choice has an
> > additional printer manager that has more functionality than the one
> > presented to me; I generally expect that the most feature-complete method
> > will be the default.
> 
> I would expect System Settings to contain essential printing functionality.
> It's purpose is to provide a centralised UI for system level operations;
> this is what all the other major OSs do, and will be familiar to users of
> those systems.

Essential is one of those words which is subject to a vast range of interpretation.

It's entirely unclear to me what the essential missing functionality that is being added exactly is. There are numerous pages listing things...

* https://live.gnome.org/ThreePointFive/Features/PrinterPanelImprovements
* https://live.gnome.org/Design/SystemSettings/Printers

...but I see things like goals and non-goals, and also things like "support for samba should be added" but I'm reading that it's not going to be added. "Add more options to options".... you get the picture.


> 
> Using specialist tools for advanced functionality is quite common. We just
> need to make sure that System Settings covers the basics.
> 
> > * I see nothing about an upgrade path here. What happens to people who
> > already utilize the capabilities in system-config-printer that are not
> > supported in GNOME system settings?
> 
> If someone misses system-config-printer, they can simply install it. That's
> the natural thing to do if you want to use a tool that isn't currently
> installed.
> 
> > Overall, I see very little awesomeness in making the sole option for
> > printing at install time be a choice which is essentially a regression from
> > what Fedora has provided in the past.
> 
> This would be a great move for the default desktop user experience. It would
> ensure that System Settings is able to play its role as a one-stop-shop for
> system-level activities. It would also help to clean up the Activities
> Overview, which will be a huge improvement. Making it easier to find and
> launch applications is vital.
> 
> > If the goal is to unclutter the applications view, as described in
> > https://fedoraproject.org/wiki/Design/F18_Launcher_Purge -- perhaps the more
> > appropriate option would be to leave system-config-printer and remove
> > printing from gnome system settings within Fedora, until gnome has feature
> > parity.
> 
> That wouldn't help - you would still have the same number of launchers in
> the applications view, and it would be confusing to users who cannot find
> printing under system settings (which is the natural place for it).
> 
> Having two printer configuration UIs is really confusing. People will expect
> printing to be under System Settings, and for it to cover essential
> functionality. They will not understand why there are two separate
> configuration utilities. We really need to make this better for our users.

People have suggested previous that perhaps changing the name (see bug #732925) to be more indicative of advanced configurability would be logical; "Advanced Printer Manager" or something might be more logical.  

Of course, you'd only want to do that in the gnome spin.

>  
> > Regardless, a change like this (removing system-config-printer from default)
> > would likely need to follow the feature process; documentation would need to
> > change, other desktops need to not be adversely affected, release notes
> > would be needed, upgrade questions answered. We are well past the submission
> > deadline, and nearly a week past feature freeze, at this point, for F18.
> 
> I've consulted a number of people in the Fedora community about this, and no
> one else has said that these changes should be proposed as a feature. I can
> communicate any changes to the documentation team, should that be necessary.

It's not just docs folks (who, incidentally, have a plethora of incredibly detailed information referencing system-config-printers in their documentation; also, twaugh has extended information on the fedora wiki about printers, etc.).

Feature policy cites, among other possibilities, two things that, IF YOU SAY YES, in the event you're not sure, should tell you that you should file a feature:

Is your package included in the default install of one of the main spins?
Is your package the default application of its type?

Along with these items from the "definition of a feature": "Noteworthy enough to call out in the release notes," "highly user visible changes (beyond artwork or theme changes)"

system-config-printer is in the default list of printing packages in comps, and basically filters out to all the desktops (save for those who have removed it/changed it in kickstart files). Removing it adversely affects other desktops (xfce, lxde, and i am really not sure how sugar would handle it at all, since they have this whole co-located universe of gnome and sugar stuff, at least on the XO, not sure exactly for the SOAS spin).  The KDE kickstart directly references removing system-config-printer and replacing it with system-config-printer-kde.  There are plenty of people that should see this, and features allow for that news to get out to people, particularly when it's a removal or substitution of a new thing for an old thing that is a default piece of functionality.

I would also say that the removal of system-config-printer from a default install, or at least from the GNOME spin, is release-note-worthy, particularly if people will need to reinstall it to gain specific functionality (samba, sharing, etc).  The addition of new functionality would also be useful for release notes.  And while you have said that you would be willing to relay the info to the docs team, the feature process is the optimal way for them to receive this information.

Also: I'm not sure how this feature interrelates with printing in System Settings, if it affects anything at all (or if work being done in 3.6 will affect how this feature can work). 
https://fedoraproject.org/wiki/Features/AvahiDefaultOnDesktop

As for visibility: printing is pretty highly user-visible; if we are introducing a lot of new things, then yes, there should be a feature page.  If we're getting rid of something people have expected to be there for some time, there should be a feature page.

Finally:
Printing, despite not being a release-blocking issue, is still incredibly visible to end users.  Tim has done an excellent job, along with others (including Marek, who has helped him), in doing test days whenever we're introducing new functionality in printing, so that we don't wind up shipping out printing that is less than optimal, or broken advertised new functionality, esp. since it's not tested as part of the routine QA tests.

If we are wanting to be committed to (a) removing system-config-printers from the gnome spin and (b) having all sorts of new functionality and new dialogs and whatnot in the system settings printing manager, I would think that we would want to test the new functionality included, make sure that it functions properly and as expected, etc. (This is also the type of thing that results from having a feature page; having a test plan, a plan for "what happens if it doesn't work," etc.)
Comment 11 Peter Robinson 2012-08-13 19:04:09 EDT
> other desktops (xfce, lxde, and i am really not sure how sugar would handle
> it at all, since they have this whole co-located universe of gnome and sugar
> stuff, at least on the XO, not sure exactly for the SOAS spin).  The KDE

It's removed on both SoaS and the XO. The printing stack takes up a lot of space and isn't really modular so is generally removed from OLPC deployments.

From previous bug reports due to space/deps system-config-printer-udev is enough for detecting printers and installing the appropriate bits.

That aside I would like to see the options within "GNOME System Settings" be generally optional for devices with smaller amounts of storage where the functionality might not be useful (printing on a media center or tablet for example is likely not useful). and merging the printing functionality into the "GNOME System Settings" is likely to pull a whole raft of extra default deps in that previously could be easily removed.
Comment 12 Jaroslav Reznik 2012-08-14 10:28:44 EDT
For https://fedoraproject.org/wiki/Design/F18_Launcher_Purge I can definitely help you with creating Feature page and process, even asking FESCo for late Feature Freeze exeception (and feature acceptance for Fedora 18). See http://fedoraproject.org/wiki/Features/Policy

As Robyn already pointed out, it does not affect directly KDE spin as we already ship our own tool based on system-config-printer-libs. Is Gnome Settings using this common library? As in case the development is stalled, it can hit us. On the other hand - having a custom spin UX that uses common code is not a bad idea. 

How does it goes with https://fedoraproject.org/wiki/Features/PrintService? It was proposed for F18 but postponed to F19.

So yeah, it's a good idea to have Feature page, as not only Gnome spin is affected for a lot of tools and it also interacts with other features (I see firewalld as example too).
Comment 13 Bill Nottingham 2012-08-14 11:02:14 EDT
I'm confused - how are spins other than the Desktop spin affected if the Desktop spin doesn't install s-c-printer? (Whether it consists of a major functionality regressions is a different issue, though.)
Comment 14 Jaroslav Reznik 2012-08-15 10:01:55 EDT
(In reply to comment #13)
> I'm confused - how are spins other than the Desktop spin affected if the
> Desktop spin doesn't install s-c-printer? (Whether it consists of a major
> functionality regressions is a different issue, though.)

Usually - the tool development is abandoned and someone from other spins has to step into the development. Or it can lead to underlaying changes in dependencies...

But as I said - these are spin maintainers decisions, still it's good to communicate it through feature or broader discussion on fedora-devel.
Comment 15 Tim Waugh 2012-08-15 11:52:37 EDT
(In reply to comment #12)
> How does it goes with https://fedoraproject.org/wiki/Features/PrintService?
> It was proposed for F18 but postponed to F19.

That isn't really related to this. It doesn't replace system-config-printer.
Comment 16 Allan Day 2013-03-07 06:34:08 EST
GNOME 3.8 will support Samba printers, and a lot of work has been done over the last cycle to improve the integrated printer settings. Would it be possible to revisit this bug for F19?
Comment 17 Adam Williamson 2013-03-07 15:07:35 EST
It seems somewhat late, as we're nearly at feature freeze; I'd at least want us to do a good overview of s-c-p functionality vs. GNOME printer applet functionality and make sure nothing is missing. I suppose we could run a Test Day. Tim, are you aware of anything significant still missing from the GNOME tool?
Comment 18 Adam Williamson 2013-03-07 15:13:57 EST
Doing a quick side-by-side of the options relating to my existing SMB printer, I see that s-c-p's 'Policies', 'Access Control' and 'Job Options' settings do not appear to have analogs in GNOME's applet. It would be reasonable to me if these are considered 'advanced' stuff that doesn't need to be available by default, though, I've never needed or wanted to touch them. The key options do appear to be there, and the 'add a printer' flow does successfully detect the printer on my network (I don't have a locally attached printer to ensure that shows up).
Comment 19 Bill Nottingham 2013-03-07 15:45:48 EST
Note that right now the assorted desktop groups are assembled from some infrastructure groups below them (x11, fonts, input methods, gstreamer). Printing is one of them, and it includes s-c-printer. Of course, the live image could exclude it, or NotShowIn could be added.
Comment 20 Tim Waugh 2013-03-11 06:54:06 EDT
One thing that seems pretty common is setting up printer sharing, i.e. sharing your printers with other people.  Is the GNOME tool able to do this part yet?

I'm happy to look at this again, but I haven't yet been able to look at current rawhide to see what progress has been made (i.e. I've tried, but control-center fails to start, or I can't log in, or ...).
Comment 21 Adam Williamson 2013-03-11 12:25:33 EDT
I was looking at current Rawhide in comment #18 (it works okay for me). Sharing features are there, but I didn't test them (I'm not sure that sharing a printer over CIFS that's already being accessed over CIFS is a great test).
Comment 22 Fedora End Of Life 2013-04-03 13:54:09 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 23 Tim Waugh 2013-08-01 06:24:10 EDT
*** Bug 697834 has been marked as a duplicate of this bug. ***
Comment 24 Adam Williamson 2013-09-27 15:23:34 EDT
Just came across something that I couldn't do with GNOME printer settings. I changed my HP printer's IP address. This is referred to explicitly in its configuration (as set up by hp-setup, I think). In system-config-printer, the 'Device URI' is exposed, and the adjustment was easy:

Device URI: hp:/net/HP_LaserJet_Professional_M1212nf_MFP?ip=192.168.XX.YY

I think you can see what I needed to change :)

In GNOME printer settings, all I see for the printer is "IP Address  localhost", and that's not even a changeable field. All I can change is the printer model, name, enablement status, and options (which is stuff about page size and so on).
Comment 25 Tim Waugh 2013-10-01 06:48:00 EDT
Similarly, I had a report that someone was unable to configure their printer using the GNOME tool even though they knew the "ipp://..." URI. (Auto-detection didn't work in either the GNOME tool or system-config-printer in that instance.)
Comment 26 Tim Waugh 2014-07-18 19:04:22 EDT
Created attachment 919215 [details]
proposed comps change

Does this change look OK?
Comment 28 Fedora End Of Life 2015-01-09 17:31:04 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 29 Fedora End Of Life 2015-02-18 06:08:42 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.